unit UnidadMenuprincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActiveX, shellapi, WbemScripting_TLB;

type
  TformMenuPrincipal = class(TForm)
    Button1: TButton;
    txtDatosProcesador: TMemo;
    LWEB: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

function obtenerDatosWMI (propiedad, clave, rama : string) : string;
var
  Locator:  ISWbemLocator;
  Services: ISWbemServices;
  SObject:  ISWbemObject;
  ObjSet:   ISWbemObjectSet;
  SProp:    ISWbemProperty;
  Enum:     IEnumVariant;
  Value:    Cardinal;
  TempObj:  OleVariant;
  SN, consultaSQL : string;
begin
  try
  Locator := CoSWbemLocator.Create;
  //conectamos con el servicio WMI
  Services :=  Locator.ConnectServer('',
      rama, '', '', '','', 0, nil);
  consultaSQL := 'SELECT ' + propiedad + ' FROM ' + clave;
  try
    ObjSet := Services.ExecQuery(consultaSQL, 'WQL',
        wbemFlagReturnImmediately and wbemFlagForwardOnly , nil);
    Enum := (ObjSet._NewEnum) as IEnumVariant;
    while (Enum.Next(1, TempObj, Value) = S_OK) do
    begin
      SObject := IUnknown(tempObj) as ISWBemObject;
      SProp := SObject.Properties_.Item(propiedad, 0);
      if VarIsNull(SProp.Get_Value) then
        result := ''
      else
      begin
        SN := SProp.Get_Value;
        result :=  SN;
      end;
    end;
    except
     on exception do
       result := '<desconocido>';
     end;
  except
    result := '<desconocido>';
  end;
end;




procedure TformMenuPrincipal.Button1Click(Sender: TObject);
begin
  txtDatosProcesador.Clear;

  txtDatosProcesador.Lines.Add ('N procesadores lgicos: ' +
      obtenerDatosWMI('NumberOfLogicalProcessors', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('N de cores (ncleos): ' +
      obtenerDatosWMI('NumberOfCores', 'Win32_Processor', 'root\CIMV2'));

  case strtoint(obtenerDatosWMI('Architecture', 'Win32_Processor', 'root\CIMV2')) of
    0 : txtDatosProcesador.Lines.Add ('Modelo procesador: 0 - x86');
    1 : txtDatosProcesador.Lines.Add ('Modelo procesador: 1 - MIPS');
    2 : txtDatosProcesador.Lines.Add ('Modelo procesador: 2 - Alpha');
    3 : txtDatosProcesador.Lines.Add ('Modelo procesador: 3 - PowerPC');
    6 : txtDatosProcesador.Lines.Add ('Modelo procesador: 6 - Intel Itanium Processor Family (IPF)');
    9 : txtDatosProcesador.Lines.Add ('Modelo procesador: 9 - x64');
  end;

  case strtoint(obtenerDatosWMI('CpuStatus', 'Win32_Processor', 'root\CIMV2')) of
    0 : txtDatosProcesador.Lines.Add ('Estado CPU: Desconocido');
    1 : txtDatosProcesador.Lines.Add ('Estado CPU: Habilitado');
    2 : txtDatosProcesador.Lines.Add ('Estado CPU: Deshabilitado por el usuario en la BIOS');
    3 : txtDatosProcesador.Lines.Add ('Estado CPU: Deshabilitado en la BIOS por error');
    4 : txtDatosProcesador.Lines.Add ('Estado CPU: Inactivo');
    5 : txtDatosProcesador.Lines.Add ('Estado CPU: Reservado');
    6 : txtDatosProcesador.Lines.Add ('Estado CPU: Reservado');
    7 : txtDatosProcesador.Lines.Add ('Estado CPU: Otro');        
  end;

  case strtoint(obtenerDatosWMI('ProcessorType', 'Win32_Processor', 'root\CIMV2')) of
    1 : txtDatosProcesador.Lines.Add ('Tipo de procesador: Otro');
    2 : txtDatosProcesador.Lines.Add ('Tipo de procesador: Desconocido');
    3 : txtDatosProcesador.Lines.Add ('Tipo de procesador: Central');
    4 : txtDatosProcesador.Lines.Add ('Tipo de procesador: Matemtico');
    5 : txtDatosProcesador.Lines.Add ('Tipo de procesador: DSP');
    6 : txtDatosProcesador.Lines.Add ('Estado CPU: Vdeo');
    7 : txtDatosProcesador.Lines.Add ('Estado CPU: Otro');        
  end;

  txtDatosProcesador.Lines.Add ('Tamao de datos (DataWith) (bit): ' +
      obtenerDatosWMI('DataWidth', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Nombre: ' +
      obtenerDatosWMI('Name', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Tamao cach L2 (KB): ' +
      obtenerDatosWMI('L2CacheSize', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Velocidad cach L2 (MHz): ' +
      obtenerDatosWMI('L2CacheSpeed', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Tamao cach L3 (KB): ' +
      obtenerDatosWMI('L3CacheSize', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Velocidad cach L3 (MHz): ' +
      obtenerDatosWMI('L3CacheSpeed', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Socket: ' +
      obtenerDatosWMI('SocketDesignation', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Velocidad (MHz): ' +
      obtenerDatosWMI('CurrentClockSpeed', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Voltaje (V): ' +
      obtenerDatosWMI('CurrentVoltage', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Descripcin: ' +
      obtenerDatosWMI('Description', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Descripcin familia (otra): ' +
      obtenerDatosWMI('OtherFamilyDescription', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Fabricante: ' +
      obtenerDatosWMI('Manufacturer', 'Win32_Processor', 'root\CIMV2'));

  txtDatosProcesador.Lines.Add ('Revisin: ' +
      obtenerDatosWMI('Revision', 'Win32_Processor', 'root\CIMV2'));
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
